public class Roman {

	public static final String ROMAN_MAX = "maximus";
	public static final String ROMAN_MIN = "minimus";

	public static String toRoman(int arabic){
		if(arabic >= 10000000) return ROMAN_MAX;
		if(arabic <= 0) return ROMAN_MIN;
		StringBuffer a = new StringBuffer(""+arabic);
		StringBuffer output = new StringBuffer(33);
		while(a.length() > 0){
			char t = a.charAt(0);
			int x = a.length();
			a.deleteCharAt(0);
			switch(t){
				case '9':
					switch(x){
						case 7:
							output.append("MMMMMMMMM");
							break;
						case 6:
							output.append("CM");
							break;
						case 5:
							output.append("XC");
							break;
						case 4:
							output.append("IX");
							break;
						case 3:
							output.append("cm");
							break;
						case 2:
							output.append("xc");
							break;
						case 1:
							output.append("ix");
							break;
					}
					break;
				case '8':
					switch(x){
						case 7:
							output.append("MMMMMMMM");
							break;
						case 6:
							output.append("DCCC");
							break;
						case 5:
							output.append("LXXX");
							break;
						case 4:
							output.append("VIII");
							break;
						case 3:
							output.append("dccc");
							break;
						case 2:
							output.append("lxxx");
							break;
						case 1:
							output.append("viii");
							break;
					}
					break;
				case '7':
					switch(x){
						case 7:
							output.append("MMMMMMM");
							break;
						case 6:
							output.append("DCC");
							break;
						case 5:
							output.append("LXX");
							break;
						case 4:
							output.append("VII");
							break;
						case 3:
							output.append("dcc");
							break;
						case 2:
							output.append("lxx");
							break;
						case 1:
							output.append("vii");
							break;
					}
					break;
				case '6':
					switch(x){
						case 7:
							output.append("MMMMMM");
							break;
						case 6:
							output.append("DC");
							break;
						case 5:
							output.append("LX");
							break;
						case 4:
							output.append("VI");
							break;
						case 3:
							output.append("dc");
							break;
						case 2:
							output.append("lx");
							break;
						case 1:
							output.append("vi");
							break;
					}
					break;
				case '5':
					switch(x){
						case 7:
							output.append("MMMMM");
							break;
						case 6:
							output.append("D");
							break;
						case 5:
							output.append("L");
							break;
						case 4:
							output.append("V");
							break;
						case 3:
							output.append("d");
							break;
						case 2:
							output.append("l");
							break;
						case 1:
							output.append("v");
							break;
					}
					break;
				case '4':
					switch(x){
						case 7:
							output.append("MMMM");
							break;
						case 6:
							output.append("CD");
							break;
						case 5:
							output.append("XL");
							break;
						case 4:
							if(arabic<10000) output.append("IIII");
							else output.append("IV");
							break;
						case 3:
							output.append("cd");
							break;
						case 2:
							output.append("xl");
							break;
						case 1:
							if(arabic<10) output.append("iiii");
							else output.append("iv");
							break;
					}
					break;
				case '3':
					switch(x){
						case 7:
							output.append("MMM");
							break;
						case 6:
							output.append("CCC");
							break;
						case 5:
							output.append("XXX");
							break;
						case 4:
							output.append("III");
							break;
						case 3:
							output.append("ccc");
							break;
						case 2:
							output.append("xxx");
							break;
						case 1:
							output.append("iii");
							break;
					}
					break;
				case '2':
					switch(x){
						case 7:
							output.append("MM");
							break;
						case 6:
							output.append("CC");
							break;
						case 5:
							output.append("XX");
							break;
						case 4:
							output.append("II");
						case 3:
							output.append("cc");
							break;
						case 2:
							output.append("xx");
							break;
						case 1:
							output.append("ii");
							break;
					}
					break;
				case '1':
					switch(x){
						case 7:
							output.append("M");
							break;
						case 6:
							output.append("C");
							break;
						case 5:
							output.append("X");
							break;
						case 4:
							output.append("I");
							break;
						case 3:
							output.append("c");
							break;
						case 2:
							output.append("x");
							break;
						case 1:
							output.append("i");
							break;
					}
					break;
			}	
		}
		return output.toString();
	}

}
